# 🗨️ Chat Cliente-Servidor en Python

Este proyecto es una aplicación de chat basada en una arquitectura cliente-servidor utilizando Python. Implementa `socket` para la comunicación en red, `threading` para manejar múltiples clientes simultáneamente y `tkinter` para la interfaz gráfica. Permite a los usuarios conectarse a un servidor de chat y enviar mensajes en tiempo real.

## 📌 Características

- ✅ **Servidor multicliente** basado en `socket` y `threading`.
- ✅ **Clientes con interfaz gráfica** (Tkinter) para conectarse y chatear.
- ✅ **Interfaz amigable** con opciones de conexión y envío de mensajes.
- ✅ **Soporte para múltiples clientes** en una misma sesión de chat.
- ✅ **Servidor ejecutable en segundo plano** desde la interfaz del cliente.


## 🔧 Dependencias

Este proyecto usa módulos estándar de Python, por lo que no es necesario instalar paquetes adicionales. Sin embargo, se recomienda usar un entorno virtual para mantener el aislamiento del proyecto.

Módulos utilizados:
- [`socket`](https://docs.python.org/3/library/socket.html) - Para la comunicación en red.
- [`threading`](https://docs.python.org/3/library/threading.html) - Para manejar múltiples clientes en paralelo.
- [`tkinter`](https://docs.python.org/3/library/tkinter.html) - Para la interfaz gráfica de la aplicación.

## 🎥 Video Tutorial

[![Ver en YouTube](https://img.youtube.com/vi/VIDEO_ID/maxresdefault.jpg)](https://youtu.be/GvhLM6T-Zhg)


## 🚀 Instalación y Ejecución

### 1️⃣ Clonar el repositorio
```bash
git git clone https://git.ieslamar.org/DonWilliam/ChatPersonas.git
cd ChatPersonas





